﻿/*
 * 24 Puzzle
 * Copyright (C) 2008 Michael Birken
 * 
 * This file is part of 24 Puzzle.
 *
 * 24 Puzzle is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published 
 * by the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * 24 Puzzle is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TwentyFourPuzzle {

  public class Example1 {

    private double[,] permutations = {
      { 1, 3, 4, 6, },
      { 1, 3, 6, 4, },
      { 1, 4, 3, 6, },
      { 1, 4, 6, 3, },
      { 1, 6, 3, 4, },
      { 1, 6, 4, 3, },
      { 3, 1, 4, 6, },
      { 3, 1, 6, 4, },
      { 3, 4, 1, 6, },
      { 3, 4, 6, 1, },
      { 3, 6, 1, 4, },
      { 3, 6, 4, 1, },
      { 4, 1, 3, 6, },
      { 4, 1, 6, 3, },
      { 4, 3, 1, 6, },
      { 4, 3, 6, 1, },
      { 4, 6, 1, 3, },
      { 4, 6, 3, 1, },
      { 6, 1, 3, 4, },
      { 6, 1, 4, 3, },
      { 6, 3, 1, 4, },
      { 6, 3, 4, 1, },
      { 6, 4, 1, 3, },
      { 6, 4, 3, 1, },
    };

    private char[] operators = { '+', '-', '*', '/' };

    public void Solve() {
      foreach (char p in operators) {
        foreach (char q in operators) {
          foreach (char r in operators) {
            for (int i = 0; i < 24; i++) {
              double a = permutations[i, 0];
              double b = permutations[i, 1];
              double c = permutations[i, 2];
              double d = permutations[i, 3];

              if (F(F(a, p, b), r, F(c, q, d)) == 24) {
                Console.WriteLine("({0} {1} {2}) {3} ({4} {5} {6}) = 24",
                    a, p, b, r, c, q, d);
                return;
              }
              if (F(F(F(a, p, b), q, c), r, d) == 24) {
                Console.WriteLine("(({0} {1} {2}) {3} {4}) {5} {6} == 24",
                    a, p, b, r, c, q, d);
                return;
              }
              if (F(F(a, p, F(b, q, c)), r, d) == 24) {
                Console.WriteLine("({0} {1} ({2} {3} {4})) {5} {6} == 24",
                    a, p, b, r, c, q, d);
                return;
              }
              if (F(a, p, F(b, q, F(c, r, d))) == 24) {
                Console.WriteLine("{0} {1} ({2} {3} ({4} {5} {6})) == 24",
                    a, p, b, r, c, q, d);
                return;
              }
              if (F(a, p, F(F(b, q, c), r, d)) == 24) {
                Console.WriteLine("{0} {1} (({2} {3} {4}) {5} {6}) == 24",
                    a, p, b, r, c, q, d);
                return;
              }
            }
          }
        }
      }
    }

    private double F(double a, char op, double b) {
      switch (op) {
        case '+':
          return a + b;
        case '-':
          return a - b;
        case '*':
          return a * b;
        default:
          return a / b;
      }
    }
  }
}
