﻿/*
 * 24 Puzzle
 * Copyright (C) 2008 Michael Birken
 * 
 * This file is part of 24 Puzzle.
 *
 * 24 Puzzle is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published 
 * by the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * 24 Puzzle is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TwentyFourPuzzle {
  public class Example2 {
    private void PrintPermutations(char[] operators, int index, char[] permutation) {
      if (index == permutation.Length) {
        PrintArray(permutation);
      } else {
        for (int i = 0; i < operators.Length; i++) {
          permutation[index] = operators[i];
          PrintPermutations(operators, index + 1, permutation);
        }
      }
    }

    public void PrintPermutations(char[] operators) {
      PrintPermutations(operators, 0, new char[operators.Length]);
    }

    private void PrintArray(char[] permutation) {
      StringBuilder sb = new StringBuilder();
      sb.Append(permutation[0]);
      for (int i = 1; i < permutation.Length; i++) {
        sb.Append(" ");
        sb.Append(permutation[i]);        
      }
      Console.WriteLine(sb.ToString());
    }
  }
}
