﻿using System;
/*
 * 24 Puzzle
 * Copyright (C) 2008 Michael Birken
 * 
 * This file is part of 24 Puzzle.
 *
 * 24 Puzzle is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published 
 * by the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * 24 Puzzle is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */

using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TwentyFourPuzzle {
  public class Example3 {

    private void PrintPermutations(double[] numbers, int index, 
        double[] permutation, bool[] available) {
      if (index == numbers.Length) {
        PrintArray(permutation);
      } else {
        double lastNumber = Double.NaN;
        for (int i = 0; i < available.Length; i++) {
          if (available[i] && numbers[i] != lastNumber) {
            available[i] = false;
            permutation[index] = lastNumber = numbers[i];
            PrintPermutations(numbers, index + 1, permutation, available);
            available[i] = true;
          }
        }
      }
    }

    public void PrintPermutations(double[] numbers) {
      Array.Sort(numbers);
      bool[] available = new bool[numbers.Length];
      for (int i = 0; i < available.Length; i++) {
        available[i] = true;
      }
      PrintPermutations(numbers, 0, new double[numbers.Length], available);
    }

    private void PrintArray(double[] permutation) {
      StringBuilder sb = new StringBuilder();
      sb.Append("{ ");
      sb.Append(permutation[0]);
      for (int i = 1; i < permutation.Length; i++) {
        sb.Append(", ");
        sb.Append(permutation[i]);
      }
      sb.Append(" }");
      Console.WriteLine(sb.ToString());
    }
  }
}
