﻿/*
 * 24 Puzzle
 * Copyright (C) 2008 Michael Birken
 * 
 * This file is part of 24 Puzzle.
 *
 * 24 Puzzle is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published 
 * by the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * 24 Puzzle is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TwentyFourPuzzle {
  public class Program {

    private static uint[] factorials = {
      1,
      1,
      2,
      6,
      24,
      120,
      720,
      5040,
      40320,
      362880,
      3628800,
      39916800,
      479001600,
    };

    public static void Solve24Puzzle() {
      Example4 example4 = new Example4();
      example4.Solve(
         new double[] { 1, 3, 4, 6 },
         new UnaryOperator[0],
         new BinaryOperator[] { 
           new BinaryOperator((a, b) => a + b, "+"),
           new BinaryOperator((a, b) => a - b, "-"),
           new BinaryOperator((a, b) => a * b, "*"),
           new BinaryOperator((a, b) => a / b, "/")
         },
         24);
    }

    public static void SolveFour4sPuzzle() {
      Example5 example5 = new Example5();
      UnaryOperator negate = new UnaryOperator(a => -a, "-", true);
      UnaryOperator squareRoot 
          = new UnaryOperator(a => Math.Sqrt(a), "sqrt", true);  
      UnaryOperator factorial = new UnaryOperator(a => { 
          if (a == Math.Floor(a) && a >= 0 && a <= 12) {
            return factorials[(int)a]; 
          } else {
            return Double.NaN; 
          }
      }, "!", false);
      example5.FindAll(
         new double[] { 4, 4, 4, 4 },
         new UnaryOperator[] { negate, squareRoot, factorial },
         new BinaryOperator[] { 
           new BinaryOperator((a, b) => a + b, "+"),
           new BinaryOperator((a, b) => a - b, "-"),
           new BinaryOperator((a, b) => a * b, "*"),
           new BinaryOperator((a, b) => a / b, "/"),
           new BinaryOperator((a, b) => Math.Pow(a, b), "^")
         });
    }

    public static void Main(string[] args) {
      Solve24Puzzle();
    }
  }
}
